{%- import "rda_dmp_cs/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "rda_dmp_cs/_utils.j2" as utils with context -%}
{%- import "rda_dmp_cs/_monitoring.j2" as monitoring with context -%}
{%- import "rda_dmp_cs/_constraints.j2" as constraints with context -%}
{%- import "rda_dmp_cs/_contributor_contact.j2" as contributor with context -%}
{%- import "rda_dmp_cs/_dataset.j2" as dataset with context -%}
{%- import "rda_dmp_cs/_distribution.j2" as distribution with context -%}
{%- import "rda_dmp_cs/_global_variables.j2" as globals with context -%}


{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#- ----------------------------------------------------------------------- -#}
{#- to see the latest document context:                                     -#}
{#-   https://guide.ds-wizard.org/en/latest/_images/document-context.svg    -#}
{#-                                                                         -#}
{#-  the document context giving access to all DSW entities                 -#}
{%- set dc = ctx|to_context_obj -%}

{#-  the dmp object which will be built as the RDA DMP CS output of our questionnaire  -#}
{{ utils.deepCopy(rda_dmp_cs.dmp_skeleton) }}
{%- set dmp_being_built = utils.global_ns.var_stack.pop() -%}

{#- ----------------------------------------------------------------------- -#}
{#-  end of GLOBAL VARIABLES                                                -#}
{#- ----------------------------------------------------------------------- -#}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="in main") -%}

{#- ----------------------------------------------------------------------- -#}
{#-  Annotation MACROS                                                        -#}
{#- ----------------------------------------------------------------------- -#}


{#- we'll have two types of annotations   -#}
{#-  ActionAnnotations: annotations that trigger an action -#}
{#-  Value Annotations: annotations that set values to the RDA DMP CS entities -#}
{#-  -#}
{#-  -#}
{#- ActionAnnotations: those annotations that will be used -#}
{#- to, for example, create a new object, or any other type of action  -#}
{#- for example, rda.contributor is an object  -#}
{#- { "name": none,  "mbox": none, "role": [], "contributor_id": {} }  -#}
{#- and will be associated with the annotation 'rdaContributor' -#}
{#- -#}
{#- all these annotation will be used to trigger the creation of a new objet -#}
{#- see processActionAnnotation() -#}
{#- -#}
{#- ultimately annotation is the responsibility of the person editing the KM -#}


{%- macro processActionAnnotations(entity, path) -%}
  {#- in all this, it is obvious there is an ordering assumed between -#}
  {#- the differents events, that is,  -#}
  {#- one assumes a chronological order in the processing of the various -#}
  {#- annotations  -#}
  {#- -#} 
  {#- I'll write another output template that lists all entities -#}
  {#- together with their annotations
  {#- see https://dsw.france-bioinformatique.fr/document-template-editors/IFB:ifb-answers-insight:1.0.0 -#}

  {%- for annotation in entity.annotations -%}
    {{ monitoring.trackAnnotation(annotation) }}
    {%- if annotation == "Infrastructure" -%}
      {#- do nothing: this annotation seems useless as for now: -#}
      {#- for RDA-DMP-CS, the only relevant field to fill in is rdaDMP.dataset.distribution.title -#}
      {#- plus, in our context, only one infrastructure is accepted -#}
    {%- elif annotation == "InfrastructurePhysicalSite" -%}
    {%- elif annotation == "Contact" -%}
      {{ contributor.createAndFillRdaContact(dmp_being_built) }}
    {%- elif annotation == "Contributor" -%}
      {{ contributor.createRdaContributor(globals, dmp_being_built) }}
    {%- elif annotation == "ContributorId" -%}
      {{ contributor.createRdaContributorId(globals, dmp_being_built) }}
    {%- elif annotation == "Dataset" -%}
      {{ dataset.createRdaDataset(globals, dmp_being_built) }}
    {%- elif annotation == "DatasetId" -%}
      {{ dataset.createRdaDatasetDatasetId(globals, dmp_being_built) }}
    {%- endif -%}
  {%- endfor -%}
{%- endmacro -%}


{%- macro processGenericAnnotations(entity, reply, path) -%}

  {#- as said in processActionAnnotation, because of the -#}
  {#- chronological order of annotations' appearance -#}
  {#- we basically assume that objects to be updated have already been created  -#}
  {#- -#} 
  {#- obviously, this is responsibility of the person annotating the KM...-#} 
  {%- for annotation in entity.annotations -%}

    {%- if annotation == "ContributorName" -%}
      {{ contributor.processRdaContributorName(globals, dmp_being_built, reply) }}
    {%- elif annotation == "ContributorIdType" -%}
      {{ contributor.processRdaContributorIdType(globals, dmp_being_built, reply) }}
    {%- elif annotation == "ContributorIdIdentifier" -%}
      {{ contributor.processRdaContributorIdIdentifier(globals, dmp_being_built, reply) }}
    {%- elif annotation == "ContributorIdROR" -%}
      {{ contributor.createAndFillRdaContributorIdROR(globals, dmp_being_built, reply) }}
    {%- elif annotation == "ContributorRole" -%}
      {{ contributor.processRdaContributorRole(globals, dmp_being_built, reply) }}
    {%- elif annotation == "ContributorMbox" -%}
      {{ contributor.processRdaContributorMbox(globals, dmp_being_built, reply) }}
    {%- elif annotation == "DatasetName" -%}
      {{ dataset.processRdaDatasetName(globals, dmp_being_built, reply) }}
    {%- elif annotation == "DatasetType" -%}
      {{ dataset.processRdaDatasetType(dmp_being_built, reply) }}
    {%- elif annotation == "DatasetDescription" -%}
      {{ dataset.processRdaDatasetDescription(dmp_being_built, reply) }}
    {%- elif annotation == "DatasetIdIdentifier" -%}
      {{ dataset.processRdaDatasetIdIdentifier(globals, dmp_being_built, reply, path) }} 
    {%- elif annotation == "DatasetIdType" -%}
      {{ dataset.processRdaDatasetIdType(globals, dmp_being_built, reply, path) }}
    {%- elif annotation == "DataELSINames" -%}
      {{ dataset.setELSIConcernedDatasetNames(globals, entity, reply) }}
    {%- elif annotation == "DatasetPersonalData" -%}
      {{ dataset.processRdaPersonalData(globals, dmp_being_built, reply) }}
    {%- elif annotation == "DatasetSensitiveData" -%}
      {{ dataset.processRdaSensitiveData(globals, dmp_being_built, reply) }}
    {%- elif annotation == "InfrastructureName" -%}
      {{ distribution.processRdaInfrastructureName(globals, reply) }} 
    {%- elif annotation == "InfrastructureAcronym" -%}
      {{ distribution.processRdaInfrastructureAcronym(globals, reply) }} 
    {%- elif annotation == "InfrastructureURL" -%}
      {{ distribution.processRdaInfrastructureURL(globals, reply) }} 
    {%- elif annotation == "InfrastructurePhysicalSiteName" -%}
      {{ distribution.processRdaInfrastructurePhysicalSiteName(globals, reply) }} 
    {%- elif annotation == "InfrastructurePhysicalSiteURL" -%}
      {{ distribution.processRdaInfrastructurePhysicalSiteURL(globals, reply) }} 
    {%- endif -%}
  {%- endfor -%}

{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  ANSWERS MACROS                                                         -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderAnswerValue(question, reply, path) -%}
  {%- if reply is of_type("StringReply") -%}
    {%- set answer = reply.value -%}
  {%- else -%}
    {%- set answer = reply.value|markdown  -%}
    {%- if reply.is_integration -%}
      {#- Integration -#}
      {%- set integration = question.integration -%}
      {%- set answer = integration.item(reply.item_id) -%}
    {%- endif -%}
  {%- endif -%}
  
  {{ processGenericAnnotations(question, answer, path) }}
{%- endmacro -%}


{%- macro renderAnswerOption(question, reply, path) -%}
  {%- set answer = reply.answer -%}
  {#- both option question -#}
  {#- and the options maybe annotated, -#}
  {#- with the same annotation (not quite recommended) or not -#}
  {#- but the option annotation is only considered as an action annotation -#}

  {#- it is the responsibilty of the person editing the KM -#}
  {#- to make sure that annotations are consistent:   -#}
  {#- for example, if both question and option are annotated -#}
  {#- in such a way that the annotations trigger the creation -#}
  {#- of same object, then this might indeed be a problem...  -#}

  {#- track the answer/option's uuid -#}
  {%- set path = path ~ '.' ~ answer.uuid -%}
  {{ monitoring.trackOptionPathStart(globals, path) }}
  
  {{ processGenericAnnotations(question, answer.label, path) }}
  {{ processActionAnnotations(answer, path) }}

  {%- for question in answer.followups -%}
    {{ renderQuestion(question, path) }}
  {%- endfor -%}

  {{ monitoring.trackPathEnd(globals) }}
{%- endmacro -%}

{%- macro renderChoiceList(question, reply, path) -%}
  
  {%- for choice in question.choices -%}
    {%- if choice in reply.choices -%}
      {#- as in the case for option question, both the multichoice question -#}
      {#- and the choices maybe annotated, -#}
      {#- with the same annotation (not quite recommended) or not -#}
      {#- but the choice annotation is only considered as an action annotation -#}
      
      {{ processGenericAnnotations(question, choice.label, path) }}
      {{ processActionAnnotations(choice, path) }}

{%- endif -%}
{%- endfor -%}
{%- endmacro -%}


{%- macro renderAnswerList(question, reply, path) -%}
  {#- ItemList questions may only be annotated with action annotations -#}
  {#- -#}
  {#- we need helper macros to handle when items in the ItemList are processed -#}
  {#- at the start and the end: we can then clearly track annotations -#}
  {#- from all the item blocks corresponding to the ItemList question -#}
  {#- -#}
  {#- doing without these helpers would require to deal with respective paths -#}
  {#- when processing each annotation, a cumbersome and difficult process -#}
  {#- -#}
  
  {#- we prepare and append an empty list which will gather processed annotations -#}
  {#- as they are seen -#}
  {{ monitoring.trackItemListStart() }} 
  
  {%- set itemPathPrefix = path ~ '.' -%}
  {%- for item in reply.items -%}
    {#- create (action annotation) for any existing item -#}
    {#- possible limits on number is dealt with for each -#}
    {#- specific annotation  -#}
    {#- {{ "item " ~ item }}  -#}
    
    {%- set itemPath = itemPathPrefix ~ item -%}
    {{ monitoring.trackItemPathStart(globals, itemPath) }}

    {{ processActionAnnotations(question, itemPath) }}
    {%- for question in question.followups -%}           
      {{ renderQuestion(question, itemPath) }}        
    {%- endfor -%}

    {{ monitoring.trackPathEnd(globals) }}
  {%- endfor -%}

  {{ monitoring.processItemListEnd(globals, dmp_being_built) }}
  
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  QUESTION MACROS                                                        -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderQuestionReply(question, path) -%}    
  {%- set reply = question.replies.get(path) -%}    
  {%- if reply and reply.value -%}
    {#- process all questions as long as they have answers -#}

    {{ monitoring.trackPathStart(globals, path) }}
 {#-   {{ "--question-- " ~ question.title ~ " paths.stack " ~ globals.global_ns.paths.stack }} -#}

    {%- if question is of_type('ValueQuestion') and reply is of_type('StringReply') -%}
      {{ renderAnswerValue(question, reply, path) }}        
    {%- elif question is of_type('OptionsQuestion') and reply is of_type('AnswerReply') -%}
      {{ renderAnswerOption(question, reply, path) }}        
    {%- elif question is of_type('ListQuestion') and reply is of_type('ItemListReply') -%}
      {{ renderAnswerList(question, reply, path) }}        
    {%- elif question is of_type('IntegrationQuestion') and reply is of_type('IntegrationReply') -%}
      {{ renderAnswerValue(question, reply, path) }}       
     {%- elif question is of_type('MultiChoiceQuestion') and reply is of_type('MultiChoiceReply') -%}
      {{ renderChoiceList(question, reply, path) }}
    {%- endif -%}
 
    {{ monitoring.trackPathEnd(globals) }}
  {%- endif -%}
{%- endmacro -%}

{%- macro renderQuestion(question, path) -%}
  {%- set path = path ~ '.' ~ question.uuid -%}    
  {{ renderQuestionReply(question, path) }}
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  CHAPTER MACROS                                                         -#}
{#- ----------------------------------------------------------------------- -#}
{%- macro renderChapter(chapter) -%}
  {{ processActionAnnotations(chapter, chapter.uuid) }}

  {%- for question in chapter.questions -%}        
    {{ renderQuestion(question, chapter.uuid) }}    
  {%- endfor -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}
{%- macro render() -%}
  {%- for chapter in dc.km.chapters -%}    
    {{ renderChapter(chapter) }}
  {%- endfor -%}
{%- endmacro -%}

{#- ----------------------------------------------------------------------- -#}

{%- macro renderAndCheckJasonObject() -%}

  {{ render() }}
  {{ constraints.checkConstraints(dmp_being_built)  }}

  {{ "distribution " ~ globals.global_ns.distribution_vars }}

  {%- set final_json_object = {} -%}
  {%- do final_json_object.update({ "dmp" : dmp_being_built }) %}
  {{ final_json_object|tojson(4) }}

{%- endmacro -%}


{{ renderAndCheckJasonObject() }}












